package controller;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Formattable;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.TargetDataLine;

public class Wave8To16BpsConverter extends AudioInputStream {

	private AudioInputStream delegate;
	
	private int bps;

	private void setInputFormat(AudioFormat f) {}
	
	
	public Wave8To16BpsConverter(InputStream stream, AudioFormat format,
			long length) {
		super(stream, format, length);
		setInputFormat(format);
	}
	
	public Wave8To16BpsConverter(TargetDataLine target) {
		super(target);
		setInputFormat(target.getFormat());
	}
	
	public Wave8To16BpsConverter(AudioInputStream delegate) {
		super(new ByteArrayInputStream(new byte[0]), delegate.getFormat(),
				delegate.getFrameLength());
		
		setInputFormat(delegate.getFormat());
		this.delegate = delegate;
	}
	
	@Override
	public int read(byte[] b, int off, int len) throws IOException {
		return 0;
	}
	
	@Override
	public void close() throws IOException {
		if (delegate != null)
			delegate.close();
		else
			super.close();
	}
	
}
