package controller.loaders;

import gui.CassetteLogger;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import model.PData;
import controller.FileAction;

public class NativeFileLoader extends FileAction {
	@Override
	protected FileFilter[] getFilters() {
		return new FileFilter[] { 
				new FileNameExtensionFilter("Strings (*.str)", "str"),
				new FileNameExtensionFilter("Arrays (*.arr)", "arr"),
				new FileNameExtensionFilter("Video Memory (*.img)", "img"),
				new FileNameExtensionFilter("Machine Code (*.bin)", "bin"),
				new FileNameExtensionFilter("Binary Format data (*.dat)", "dat"),
				new FileNameExtensionFilter("BASIC Files (*.bas, *.txt)", "bas", "txt")
		};
	}

	@Override
	public boolean isLoadingAction() {
		return true;
	}

	@Override
	public String[] getMenuPath() {
		return new String[]{"Open"};
	}

	@Override
	public void start() {
		
		for (File f: source) {
			try {
				PData b = PData.fromNative(f.getName(), new FileInputStream(f));
				b.setDiskFiles(new File[]{f});
				cassette.addBlock(b, true);
				
				CassetteLogger.info("Loaded "+f.getName());
			} catch (IOException e) {
				CassetteLogger.warn("Error while loading "+f.getName()+":\n"+e.getClass().getName()+": "+e.getMessage());
				continue;
			}
		}
	}
}
