package controller.savers;

import model.Cassette;
import model.PData;
import model.PRawData;
import controller.IOAction;
import controller.StopCallback;

public class HexSaver implements IOAction {

	private Cassette c;
	
	@Override
	public boolean isLoadingAction() {
		return false;
	}
	
	@Override
	public boolean canStop() {
		return false;
	}

	@Override
	public String[] getMenuPath() {
		return new String[]{"Convert tab to binary"};
	}

	@Override
	public void setController(Cassette c, StopCallback s) {
		this.c = c;
	}

	@Override
	public boolean setSource() {
		// do nothing
		return true;
	}

	@Override
	public void start() {
		PData d = c.getSelected();
		
		PRawData machineCode = new PRawData();
		machineCode.setName(d.getName());
		machineCode.setAddress(d.getAddress());
		machineCode.decode(d.encodeFull());
		
		c.addBlock(machineCode, true);
	}

	@Override
	public void stop() {
		// do nothing
	}

}
