package controller.savers.migration;

import gui.PDataEditor;
import gui.widgets.ImageEditor;

import java.awt.Dimension;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.OutputStream;

import javax.imageio.ImageIO;

import model.PData;
import model.PImage;

public class PNGMigrator implements Migrator {

	@Override
	public String getDescription() {
		return "PNG";
	}

	@Override
	public String getExtension() {
		return "png";
	}

	@Override
	public boolean canMigrate(Object obj) {
		return obj instanceof PImage;
	}

	@Override
	public void migrate(PData data, OutputStream s, PDataEditor editor) throws IOException {
		if (!(data instanceof PImage) || editor == null || !(editor instanceof ImageEditor))
			throw new IllegalArgumentException();
		
		ImageEditor ie = (ImageEditor)editor; 
		Dimension d = ie.getTableDimensions();
		
		BufferedImage bi = new BufferedImage(d.width, d.height, BufferedImage.TYPE_INT_ARGB);
		ie.paintTable(bi.getGraphics(), false);

		ImageIO.write(bi, "png", s);
	}

}
