package gui;

import gui.widgets.ModificationListener;
import model.PData;

public interface PDataEditor {
	
	/**
	 * Set the data (model) object and update the editor to reflect it
	 * @param data
	 */
	public void setData(PData data);
	
	/**
	 * Update the data object to reflect changes in the editor
	 */
	public void syncData();
	
	/**
	 * Return true if a scroll pane is to be added.
	 */
	public boolean useScrollbars();
	
	/**
	 * Set a modification listener that will be called when the document is modified.
	 */
	public void setModificationListener(ModificationListener m);
}
