package gui.editor;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.SimpleAttributeSet;

public class HexDocument extends DefaultStyledDocument {

	private static final long serialVersionUID = -8332732994940372756L;

	private DefaultStyledDocument asciiDocument = new DefaultStyledDocument();
	
	/*private int getDigitCount(int len, boolean newlines) throws BadLocationException {
		int digitCount = 0;
		boolean middle = false;
		for (char c: getText(0, len).toCharArray()) {
			if (c >= '0' && c <= '9' || c >= 'A' && c < 'F' || newlines && c == '\n' && !middle) {
				if (c != '\n')
					middle = !middle;
				digitCount++;
			}
		}
		return digitCount;
	}*/
	
	private void refreshAsciiDocument(AttributeSet a) throws BadLocationException {
		StringBuffer entireBuffer = new StringBuffer();

		asciiDocument.remove(0, asciiDocument.getLength());
		
		char first = 0;
		int pos = 0;
		boolean middle = false;
		
		for (char c: getText(0, getLength()).toCharArray()) {
			
			if (c == ' ')
				continue;
			
			if (c == '\n') {
				//entireBuffer.append(c);
				continue;
			}
			
			
			if (middle) {
				char ch = (char)Integer.parseInt(""+first+c, 16);
				entireBuffer.append((ch < ' ')?'.':ch);
			}
			else {
				first = c;
			}
			
			middle = !middle;
			pos++;
			
			if (pos % 40 == 0)
				entireBuffer.append('\n');
		}
		//System.out.println("oinserting: "+entireBuffer.toString());
		asciiDocument.insertString(0, entireBuffer.toString(), a);
	}
	
	@Override
	public void insertString(int offs, String str, AttributeSet a)
			throws BadLocationException {
	
		super.insertString(offs, str.toUpperCase().replaceAll("[^0-9A-F \n]", ""), a);
		
		refreshAsciiDocument(a);
	}
	
	@Override
	public void replace(int offset, int length, String text, AttributeSet attrs)
			throws BadLocationException {
		// first remove, then insert
		
		remove(offset, length);
		insertString(offset, text, attrs);
	}
	
	@Override
	public void remove(int offs, int len) throws BadLocationException {
		super.remove(offs, len);
		
		refreshAsciiDocument(new SimpleAttributeSet());
	}
	
	public DefaultStyledDocument getAsciiDocument() {
		return asciiDocument;
	}
	
}
