package gui.editor;
import java.util.NoSuchElementException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class SimpleScanner {

	private String s;
	
	public SimpleScanner(String s) {
		this.s = s;
	}
	
	public String next(String pattern) {
		Matcher m = Pattern.compile("^("+pattern+")(.*)\n?$").matcher(s);
		
		if (!m.matches())
			throw new NoSuchElementException("no match for "+pattern);
		
		
		s = m.group(m.groupCount());
		
		return m.group(1);
	}
	
	public int moveBefore(String pattern) {
		Matcher m = Pattern.compile("^(.*+)("+pattern+".*)\n?$").matcher(s);

		if (!m.matches())
			return -1;
		
		s = m.group(2);
		
		return m.group(1).length();
	}
	
}
