package gui.widgets;

import gui.PDataEditor;
import gui.editor.PDataUpdater;

import javax.swing.JTextArea;

import model.PData;
import model.PString;

public class StringEditor extends JTextArea implements PDataEditor {
	private static final long serialVersionUID = -40073156395726094L;

	private PDataUpdater modifiedUpdater;

	private PString data;
	
	@Override
	public void setData(PData data) {
		
		this.data = (PString)data;
		setText(this.data.getString());
		
		if (modifiedUpdater != null)
			getDocument().removeDocumentListener(modifiedUpdater);
		getDocument().addDocumentListener(modifiedUpdater = new PDataUpdater(data, modificationListener));
		
	}

	@Override
	public void syncData() {
		data.setString(getText());
	}
	
	@Override
	public boolean useScrollbars() {
		return true;
	}
	
	private ModificationListener modificationListener;
	
	@Override
	public void setModificationListener(ModificationListener m) {
		modificationListener = m;
	}
}
