package model;

import java.util.ArrayList;
import java.util.LinkedList;

import controller.OptionStore;

public class Cassette extends ArrayList<PData> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7505209620132021930L;
	
	private LinkedList<CassetteListener> listeners = new LinkedList<CassetteListener>();
	private int index;
	
	private OptionStore options;
	
	public void addListener(CassetteListener l) {
		listeners.add(l);
	}
	
	public void removeListener(CassetteListener l) {
		listeners.remove(l);
	}
	
	public synchronized void addBlock(PData data, boolean dispatch) {
		add(data);
		
		if (dispatch)
			for (CassetteListener l: listeners)
				l.blockAdded(data);
	}
	
	/**
	 * set the currently selected tab (pdata element)
	 * @param index
	 */
	public void setSelected(int index) {
		this.index = index;
	}
	
	public PData getSelected() {
		if (size() == 0)
			return null;
		else
			return get(index);
	}
	
	public int getSelectedIndex() {
		return index;
	}
	
	public void setOptions(OptionStore options) {
		this.options = options;
	}
	
	public OptionStore getOptions() {
		return options;
	}
	
}
