package model;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;

public class PString extends PData {

	private String str = "";
	
	public String getString() {
		return str;
	}
	
	public void setString(String str) {
		this.str = str;
	}
	
	@Override
	public void fromInputStream(InputStream i) throws IOException {
		String d = decodeVerboseHeader(i);
		
		BufferedReader b = new BufferedReader(new InputStreamReader(i));
		
		StringBuffer sb = new StringBuffer();
		
		if (d != null)
			sb.append(d.replaceAll("[\n\r]+$", "")+"\n");
		
		String line;
		while ((line = b.readLine()) != null) {
			sb.append(line);
			sb.append('\n');
		}
		
		sb.deleteCharAt(sb.length()-1); // delete last newline
		str = sb.toString();
	}
	
	@Override
	public void toOutputStream(OutputStream o) throws IOException {
		encodeVerboseHeader(o);
		
		PrintWriter p = new PrintWriter(o);
		p.print(str);
		p.flush();
	}
	
	@Override
	public short[] encode() {
		short[] data = new short[str.length()];
		int i = 0;
		for (char c: str.toCharArray()) {
			data[i++] = (short)(c & 0xff);
		}
		
		return data;
	}
	
	@Override
	public void decode(short[] data) {
		StringBuffer b = new StringBuffer();
		for (short s: data) {
			if (s > 0)
				b.append((char)s);
		}
		
		str = b.toString();
	}
	
	@Override
	public String getDefaultExtension() {
		return "str";
	}
	
	@Override
	public char getFormat() {
		return 'X';
	}

}
